Status: Closed   

Priority: Normal   

Category:    

Customer: DIGITALWERK Product Issue

Numbers:

https://www.cip.audi.de/jira/browse/ACO

RE-9369

Department: ENTWICKLUNG Affected Products: ADTF 3.99.99 (MAIN NIGHTLY)

Requester's Priority: Low Platform: Windows 10 64bit

Support Level: 2nd Level Topic: ADTF::Common

Resolution: Product Issue Opened FAQ Links:  

Description

Supportanfrage

The adtf_install_plugin CMake macro is not safe to use when multiple CMake targets have been declared in the same source

directory. This defect is inherited from the basic CMake INSTALL method.

For all targets declared in the same source directory, only a single, common `cmake_install.cmake` file is created which doesn't

distinguish between the targets it is being invoked from. At the same time, anything listed in that file which hasn't been generated yet

creates an error for the invoking target.

E.g. when building plugins "foo" and "bar" from the same directory, clean build, then even though they have no dependencies on

each other, the first of them to finish compilation will "fail", while the last to finish will "succeed".

A second build attempt without a clean will then succeed, as the install script is then copying artifacts from the previous build for

unfinished targets. (And by that potentially introducing other spurious build failures.)

In a variant of this race conditions, both targets will succeed on first attempt, but only partially written artifacts have been installed.

Lösung

Will be solved within ACORE-9369

History

#1 - 2020-10-14 15:40 - hidden

adtf_add_post_build_install() is to blame for this defect. The convenience added by that macro clashes with CMakes design of INSTALL.

If adtf_add_post_build_install() is supposed to be kept, it must make proper use of CMakes Components system in order to limit installation strictly to

the components already built.

#2 - 2020-10-14 20:51 - hidden

- Project changed from Public Support to 10

- Status changed from New to In Progress

- Topic set to ADTF::Common

#5 - 2020-11-19 14:22 - hidden

- Status changed from In Progress to To Be Closed

- Resolution set to Product Issue Opened

- Product Issue Numbers set to https://www.cip.audi.de/jira/browse/ACORE-9369

Ja, das nervt immer wieder! Ich denke das sollten wir in ACORE-9369 mitmachen. Ich schreibs dort ins Ticket rein.

#6 - 2020-11-19 16:40 - hidden

- Project changed from 10 to Public Support

- Description updated
- Private changed from Yes to No

- Customer set to DIGITALWERK

- Department set to ENTWICKLUNG

#7 - 2022-01-17 08:17 - hidden

- Status changed from To Be Closed to Closed
